org.springframework.batch.core.job.flow.support.state

## Class SplitState

- java.lang.Object
- - org.springframework.batch.core.job.flow.support.state.AbstractState
  - - org.springframework.batch.core.job.flow.support.state.SplitState

- All Implemented Interfaces:
    FlowHolder, State
  Direct Known Subclasses:
    JsrSplitState

      public class SplitState
      extends AbstractState
      implements FlowHolder

  A `State` implementation that splits a `Flow` into multiple parallel subflows.
  Since:
    2.0
  Author:
    Dave Syer

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SplitState(java.util.Collection<Flow> flows, java.lang.String name)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected FlowExecutionStatus` | `doAggregation(java.util.Collection<FlowExecution> results, FlowExecutor executor)`
    `java.util.Collection<Flow>` | `getFlows()`
    `FlowExecutionStatus` | `handle(FlowExecutor executor)` Execute the flows in parallel by passing them to the `TaskExecutor` and wait for all of them to finish before proceeding.
    `boolean` | `isEndState()` Inquire as to whether a `State` is an end state.
    `void` | `setTaskExecutor(org.springframework.core.task.TaskExecutor taskExecutor)` Public setter for the taskExecutor.

    - ### Methods inherited from class org.springframework.batch.core.job.flow.support.state.AbstractState

      `getName, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### SplitState

          public SplitState(java.util.Collection<Flow> flows,
                            java.lang.String name)

      Parameters:
        `flows` - collection of `Flow` instances.
        `name` - the name of the state.

  - ### Method Detail

    - #### setTaskExecutor

          public void setTaskExecutor(org.springframework.core.task.TaskExecutor taskExecutor)

      Public setter for the taskExecutor.
      Parameters:
        `taskExecutor` - the taskExecutor to set

    - #### getFlows

          public java.util.Collection<Flow> getFlows()

      Specified by:
        `getFlows` in interface `FlowHolder`
      Returns:
        the flows

    - #### handle

          public FlowExecutionStatus handle(FlowExecutor executor)
                                     throws java.lang.Exception

      Execute the flows in parallel by passing them to the `TaskExecutor` and wait for all of them to finish before proceeding.
      Specified by:
        `handle` in interface `State`
      Specified by:
        `handle` in class `AbstractState`
      Parameters:
        `executor` - the context passed in by the caller
      Returns:
        a status for the execution
      Throws:
        `java.lang.Exception` - if anything goes wrong
      See Also:
        `State.handle(FlowExecutor)`

    - #### doAggregation

          protected FlowExecutionStatus doAggregation(java.util.Collection<FlowExecution> results,
                                                      FlowExecutor executor)

    - #### isEndState

          public boolean isEndState()

      Description copied from interface: `State`
      Inquire as to whether a `State` is an end state. Implementations should return false if processing can continue, even if that would require a restart.
      Specified by:
        `isEndState` in interface `State`
      Returns:
        true if this `State` is the end of processing